/*
  THS: Tiny Haskell subset 
  Lex rules
 */
%{
#include <stdio.h>
#include <string.h>

#include "types.h"
#include "parser.h"
%}
%%
[ \t\n]+                /* ignore whitespace */;
mod                     return MOD;
Int                     return INTTYPE;
True			return TRUEV;
::			return COLONCOLON;
->			return IMPLIES;
==			return EQ;
=			return IS;
>			return GT;
!=			return NE;
\+			return PLUS;
-			return MINUS;
\*			return MUL;
\/			return DIV;
\(			return OPEN;
\)			return CLOSE;
\|			return GUARD;
[0-9]+                  yylval.n=atoi(yytext); return NUMBER;
[a-z][a-z0-9]*          yylval.s=strdup(yytext);return IDENT;
.			return TOKERR;
%%
